package com.qmth.teachcloud.report.api;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import com.qmth.teachcloud.report.business.service.CallPrintOpenApiService;
import io.swagger.annotations.*;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.IOException;

/**
 * @Description:
 * @Author: CaoZixuan
 * @Date:
 */
@Api(tags = "测试请求分布式印刷开放接口Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/test/call")
@Validated
public class TestCallPrintOpenApiController {
    @Resource
    CallPrintOpenApiService callPrintOpenApiService;

    @ApiOperation(value = "试卷配置")
    @ApiResponses({@ApiResponse(code = 200, message = "试卷配置", response = Object.class)})
    @RequestMapping(value = "/paper_config", method = RequestMethod.POST)
    @Aac(auth = BOOL.FALSE)
    public Result paperConfig(@ApiParam(value = "考试id", required = true) @RequestParam Long thirdExamId,
                              @ApiParam(value = "科目编号", required = true) @RequestParam String courseCode) throws IOException {
        callPrintOpenApiService.callPaperConfig(thirdExamId,courseCode);
        return ResultUtil.ok();
    }
}
